  ///////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////
//
// Average.cpp
//
//	Average Class Body
//
///////////////////////////////////////
  ///////////////////////////////////////
  
/*

Copyright (c) 2005, Alexander Kroeller
All rights reserved.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

#include "Average.hpp"

////////////////////////////////////////////////////////////////////////////
// Construction
///////////////////////////////////////

Average::Average( int sz )
   : m_Size      ( sz ),
     m_Values    ( new double[m_Size] ),
     m_HeadIdx   ( 0 ),
     m_Sum       ( 0.0 ),
     m_FillState ( 0 )
{}

Average::~Average()
{ delete [] m_Values; }

////////////////////////////////////////////////////////////////////////////
// Class Body
///////////////////////////////////////

void Average::push( double val )
{
   if( m_FillState==m_Size )
      {
         m_Sum += val - m_Values[m_HeadIdx];
         m_Values[m_HeadIdx]=val;
      }
   else
      {
         ++m_FillState;
         m_Sum+=val;
         m_Values[m_HeadIdx]=val;
      }
   //m_HeadIdx=(headidx+1) % m_Size;
   m_HeadIdx = (m_HeadIdx + 1) % m_Size;
}

double Average::average( void )
{
   if( m_FillState==0 )
      return 0.0;
   else
      return m_Sum / double(m_FillState);
}

