////////////////////////////////////////////////////////////////////////////
//
// File.hpp
//
//	File header
//
///////////////////////////////////////

/*

Copyright (c) 2001-2005, Tim Burrell
All rights reserved.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

#ifndef __File_h
#define __File_h

#if HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdio.h>
#include "String.hpp"

typedef enum EFileOpen {
	FILE_READ,
	FILE_WRITE_OVERWRITE,
	FILE_WRITE_APPEND,
	FILE_CREATE_NEW,
	FILE_CREATE_OPEN,
	FILE_CREATE_OVERWRITE,
	FILE_CREATE_APPEND
};

class File {
public:
	bool	seekTo(unsigned int BytePos);
	int 	getPosition();
	const char * getFileName();
	int	read(const char * Buffer, int BufferSize, bool ConcatenateStr = false);
	int	readIntoBuffer(const char * Buffer, int BufferSize);
	bool	readIntoStr(const char * , int BufferSize = 4096);
	int 	readLine(char * line, int BUFSIZE);
	bool	closeFile();
	bool	openFile(const char * FileName, EFileOpen FileMode, unsigned long FileSize = 0);
	int	write(const char * Data, int DataLen);
	int	write(const char * Text);
	
	File();
	virtual ~File();

private:
	bool	checkFile(const char * FileName, EFileOpen FileMode);
	
	FILE *	m_File;

	String	m_FileName;
};

#endif // __File_h

