  ///////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////
//
// GizmoPlugin.hpp
//
//	GizmoPlugin header file
//
///////////////////////////////////////
  ///////////////////////////////////////
  
/*

Copyright (c) 2006, Tim Burrell
All rights reserved.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

#ifndef __GizmoPlugin_h
#define __GizmoPlugin_h

#include "../libGizmo/EventWatcherInterface.hpp"
#include "../libGizmo/String.hpp"

//////////////////////////////////////////////////////////////////////////////
// Class Definition
///////////////////////////////////////

class GizmoPlugin : public EventWatcherInterface {
public:
	virtual bool	checkEventsWaiting() = 0;
	virtual void	closePlugin() = 0;
	virtual int	getDeviceID() = 0;
	virtual String	getDeviceName() = 0;
	virtual String	getDeviceNameAlt() = 0;
	virtual bool	initPlugin() = 0;
	virtual bool	onPluginOpened();
	
	String		getPluginName();	
	void		setPluginName(String Name);
	
	GizmoPlugin();
	virtual ~GizmoPlugin();
	
protected:
	String		m_PluginName;

private:
};

#endif // __GizmoPlugin_h

