  ///////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////
//
// AlsaMixerInterface.hpp
//
//	AlsaMixerInterface header file
//
///////////////////////////////////////
  ///////////////////////////////////////
  
/*

Copyright (c) 2005, Tim Burrell
All rights reserved.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

#ifndef __AlsaMixerInterface_h
#define __AlsaMixerInterface_h

#if HAVE_CONFIG_H
#include "config.h"
#endif

#include "libGizmo/GizmoPlugin.hpp"
#include "libGizmo/LinkList.hpp"
#include "libGizmo/String.hpp"
#include <alsa/asoundlib.h>

//////////////////////////////////////////////////////////////////////////////
// Typedefs
///////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
// Class Definition
///////////////////////////////////////

class AlsaMixerInterface : public GizmoPlugin {
public:
	int		getDeviceID();
	virtual String	getDeviceName() = 0;
	virtual String	getDeviceNameAlt() = 0;
	
	virtual snd_mixer_elem_t * getMixerElem() = 0;
	virtual int	getSwitch() = 0;
	virtual long 	getVolume() = 0;
	virtual float	getVolumePercent() = 0;
	virtual void 	getVolumeFromCard() = 0;
	virtual void 	onMixerEvent(float VolumePercent, bool Mute) = 0;
	virtual bool 	setSwitch(int Value) = 0;
	virtual bool 	setVolumePercent(float Percent) = 0;
	
	AlsaMixerInterface();
	virtual ~AlsaMixerInterface();

	static LinkList<AlsaMixerInterface> * getPluginList();

protected:
	int		m_DeviceID;
	
private:
	static int	m_DeviceIDCurrent;
	static LinkList<AlsaMixerInterface> m_PluginList;
};

#endif // __AlsaMixerInterface_h

