  //////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
//
// ScriptFunctionAlsaMixerGetVolume.cpp
//
//	ScriptFunctionAlsaMixerGetVolume class
//
///////////////////////////////////////
  ///////////////////////////////////////
  
/*

Copyright (c) 2005, Tim Burrell
All rights reserved.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

#include "ScriptFunctionAlsaMixerGetVolume.hpp"
#include "libGizmo/Debug.hpp"

////////////////////////////////////////////////////////////////////////////
// Statics / Type Defs
///////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
// Overrides
///////////////////////////////////////

bool ScriptFunctionAlsaMixerGetVolume::executeFunction() {
	//Debug::outDebug("ScriptFunctionAlsaMixerGetVolume :: executeFunction");
	
	ScriptFuncArg * pInArg1 = getInArg(0);
	if (!pInArg1) {
		Debug::out("ScriptFunctionAlsaMixeGetVolume :: executeFunction -- No In Parameter!");
		return false;
	}
	
	ScriptFuncArg * pOutArg1 = getOutArg(0);
	if (!pInArg1) {
		Debug::out("ScriptFunctionAlsaMixerGetVolume :: executeFunction -- No Out Parameter!");
		return false;
	}
	
	// find device
	LinkList<AlsaMixerInterface> * pPluginList = AlsaMixerInterface::getPluginList();
	if (pPluginList->getSize() == 0) {
		Debug::out("ScriptFunctionAlsaMixerGetVolume :: PluginList Badness!");
		return false;
	}
	pPluginList->moveToHead();
	do {
		AlsaMixerInterface * pInt = pPluginList->getData();
		if (pInt->getDeviceID() == pInArg1->ArgNumber) {
			pOutArg1->ArgNumber = pInt->getVolumePercent();
			break;
		}
	} while (pPluginList->moveNext());
		
	return true;
}

////////////////////////////////////////////////////////////////////////////
// Global Funcs
///////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
// Construction
///////////////////////////////////////

ScriptFunctionAlsaMixerGetVolume::ScriptFunctionAlsaMixerGetVolume(AlsaMixerInterface * pPlugin) {
	m_pPlugin = pPlugin;
	FunctionName.format("alsaMixerGetVolume");
	FunctionDescription = "Gets the Volume of the Alsa Mixer";
	
	addInArg(SCRIPT_ARG_NUMBER);		// IN  DeviceID
	addOutArg(SCRIPT_ARG_NUMBER);		// OUT Mixer Level
}

ScriptFunctionAlsaMixerGetVolume::~ScriptFunctionAlsaMixerGetVolume() {
}

////////////////////////////////////////////////////////////////////////////
// Class Body
///////////////////////////////////////
