  //////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
//
// ScriptFunctionOnAlsaMixerEvent.cpp
//
//	ScriptFunctionOnAlsaMixerEvent class
//
///////////////////////////////////////
  ///////////////////////////////////////
  
/*

Copyright (c) 2005, Tim Burrell
All rights reserved.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

#include "ScriptFunctionOnAlsaMixerEvent.hpp"
#include "libGizmo/Debug.hpp"

////////////////////////////////////////////////////////////////////////////
// Statics / Type Defs
///////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
// Overrides
///////////////////////////////////////

bool ScriptFunctionOnAlsaMixerEvent::executeFunction() {
	Debug::outDebug("ScriptFunctionOnAlsaMixerEvent :: executeFunction");
		
	return true;
}

////////////////////////////////////////////////////////////////////////////
// Global Funcs
///////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
// Construction
///////////////////////////////////////

ScriptFunctionOnAlsaMixerEvent::ScriptFunctionOnAlsaMixerEvent() {
	FunctionName = "onAlsaMixerEvent";
	FunctionDescription = "Called when an Alsa Mixer Event is Detected";
	
	addInArg(SCRIPT_ARG_NUMBER);	// DeviceID
	addInArg(SCRIPT_ARG_NUMBER);	// Volume Percent
	addInArg(SCRIPT_ARG_BOOLEAN);	// Mute
	addInArg(SCRIPT_ARG_STRING);	// Card Name
	addInArg(SCRIPT_ARG_STRING);	// Mixer Name
}

ScriptFunctionOnAlsaMixerEvent::~ScriptFunctionOnAlsaMixerEvent() {
}

////////////////////////////////////////////////////////////////////////////
// Class Body
///////////////////////////////////////
