  ///////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////
//
// BMPControlInterface.hpp
//
//	BMPControlInterface header file
//
///////////////////////////////////////
  ///////////////////////////////////////
  
/*

Copyright (c) 2005, Tim Burrell
All rights reserved.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

#ifndef __BMPControlInterface_h
#define __BMPControlInterface_h

#if HAVE_CONFIG_H
#include "config.h"
#endif

#include "libGizmo/LinkList.hpp"
#include "libGizmo/String.hpp"
#include "libGizmo/GizmoPlugin.hpp"

//////////////////////////////////////////////////////////////////////////////
// Typedefs
///////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
// Class Definition
///////////////////////////////////////

class BMPControlInterface : public GizmoPlugin {
public:
	int		getDeviceID();
			
	virtual int 	bmpGetPlaylistPosition() = 0;
	virtual int	bmpGetOutputTime() = 0;
	virtual bool	bmpIsPaused() = 0;
	virtual bool	bmpIsPlaying() = 0;
	virtual bool	bmpNextTrack() = 0;
	virtual bool	bmpPause() = 0;
	virtual bool	bmpPlay() = 0;
	virtual bool	bmpPreviousTrack() = 0;
	virtual bool	bmpSeek(int Offset) = 0;
	virtual bool	bmpSetTrack(int Track) = 0;
	virtual bool	bmpStop() = 0;
				
	BMPControlInterface();
	virtual ~BMPControlInterface();

	static LinkList<BMPControlInterface> * getPluginList();

protected:
	int		m_DeviceID;
	String		m_DevicePath;
	String		m_DeviceName;
	
private:
	static int	m_DeviceIDCurrent;
	static LinkList<BMPControlInterface> m_PluginList;
};

#endif // __BMPControlInterface_h

