#if HAVE_CONFIG_H
#include "config.h"
#endif

#include <gtk/gtk.h>

// BAD bmp developers BAD!!
// Ugly hack in order to get to work
#ifndef G_BEGIN_DECLS
	#define G_BEGIN_DECLS
	#define G_END_DECLS
#endif
#ifndef G_CONST_RETURN
	#define G_CONST_RETURN const
#endif

#include <bmp/plugin.h>
#include <string.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <sys/types.h>

extern "C" {

// Func Prots
static void GizmoBMP_init(void);
static void GizmoBMP_cleanup(void);
static void GizmoBMP_about(void);
static void GizmoBMP_configure(void);
static void GizmoBMP_playback_start(void);
static void GizmoBMP_playback_stop(void);
static void GizmoBMP_render_freq(gint16 freq_data[2][256]);

#define DEV_NAME	"BMP Visualization"
#define DEV_NAME_ALT	"Song Name Here"
#define SHARED_MEM_ID	303
#define SHARED_MEM_SIZE	sizeof(unsigned char) * 5

// Global Vars
static unsigned char 	m_CharData[256];
static unsigned char *	m_Data;
static key_t		m_SHMkey;
static int		m_SHMid;
static shmid_ds 	m_ShmDS;
static unsigned char 	m_WriteNum = 0;	

// Callback functions
VisPlugin GizmoBMP_vtable = {
  NULL,					// Handle, filled in by BMP
  NULL,					// Filename, filled in by BMP
  0,					// Session ID
  NULL,					// description
  0, 					// # of PCM channels for render_pcm()
  1,					// # of freq channels wanted for render_freq()
  GizmoBMP_init,           		// Called when plugin is enabled
  GizmoBMP_cleanup,        		// Called when plugin is disabled
  GizmoBMP_about,          		// Show the about box
  GizmoBMP_configure,      		// Show the configure box
  NULL,                        		// Called to disable plugin, filled in by BMP
  GizmoBMP_playback_start, 		// Called when playback starts
  GizmoBMP_playback_stop,  		// Called when playback stops
  NULL,                        		// Render the PCM data, must return quickly
  GizmoBMP_render_freq     		// Render the freq data, must return quickly
};

// BMP entry point
VisPlugin * get_vplugin_info(void) {
	GizmoBMP_vtable.description = g_strdup_printf("GizmoDaemon VisPlugin -=- v%s", VERSION);

	return &GizmoBMP_vtable;
}

} // EXTERN <-- important yo!

static void sendVisMessage(unsigned char Value0, unsigned char Value1) {
	if (!m_Data)
		return;
		
	m_Data[0] = m_WriteNum ++;
	m_Data[1] = Value0;
	m_Data[2] = Value1;
	m_Data[3] = (((int)Value0 + (int)Value1) / 2);
	m_Data[4] = 0;
}

static void GizmoBMP_cleanup(void) {
	printf("GizmoBMP plugin: Cleanup\n");

	if (m_Data) {
		m_Data[0] = ++ m_WriteNum;
		m_WriteNum ++;
		m_Data[4] = 2;
		shmdt((void *) m_Data);
		m_Data = NULL;
	}
	//if (m_HardClose)
	//	shmctl(m_SHMid, IPC_RMID, NULL);
	m_SHMid = -1;
	m_SHMkey = 0;
}

static void GizmoBMP_init(void) {
	printf("GizmoBMP plugin: Initializing\n");

	m_SHMid = shmget(SHARED_MEM_ID, SHARED_MEM_SIZE, 0600 | IPC_CREAT);
	m_Data = (unsigned char *) shmat(m_SHMid, NULL, 0);
	if (m_Data == (unsigned char *)(-1)) {
		GizmoBMP_cleanup();
		return;
	}

	memset(m_Data, 0, SHARED_MEM_SIZE);
	m_Data[0] = ++ m_WriteNum;
	m_WriteNum ++;
	m_Data[4] = 1;
}

static void GizmoBMP_about(void) {
	printf("GizmoBMP plugin: About\n");
}

static void GizmoBMP_configure(void) {
	printf("GizmoBMP plugin: Configure\n");
}

static void GizmoBMP_playback_start(void) {
	printf("GizmoBMP plugin: Playback starting\n");

	sendVisMessage(255, 255);
}

static void GizmoBMP_playback_stop(void) {
	printf("GizmoBMP plugin: Playback stopping\n");

	sendVisMessage(0, 0);
}

static void GizmoBMP_render_freq(gint16 freq_data[2][256]) {
	// convert that data yo!
	unsigned char highest0 = 0;
	//unsigned char highest1 = 0;
	
	for (int lp = 0; lp < 256; lp ++) {
		m_CharData[lp] = (unsigned char) (255.0 * double(freq_data[0][lp]) / 32768.0);
		if (m_CharData[lp] > highest0)
			highest0 = m_CharData[lp];
	}

	/*
	for (int lp = 0; lp < 256; lp ++) {
		m_CharData[lp] = (unsigned char) (255.0 * double(freq_data[1][lp]) / 32768.0);
		if (m_CharData[lp] > highest1)
			highest1 = m_CharData[lp];
	}
	*/
	
	sendVisMessage(highest0, highest0);
}
