  ///////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////
//
// LIRC.hpp
//
//	LIRC header file
//
///////////////////////////////////////
  ///////////////////////////////////////
  
/*

Copyright (c) 2005, Tim Burrell
All rights reserved.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

#ifndef __LIRC_h
#define __LIRC_h

#if HAVE_CONFIG_H
#include "config.h"
#endif

#include "libGizmo/String.hpp"
#include <unistd.h>
#include <fcntl.h>
#include <sys/socket.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/un.h>

//////////////////////////////////////////////////////////////////////////////
// Typedefs
///////////////////////////////////////

#define LIRC_BUF_SIZE	128

//////////////////////////////////////////////////////////////////////////////
// Class Definition
///////////////////////////////////////

class LIRC {
public:
	bool		checkEventsWaiting();
	void		closeLIRC();
	bool		initLIRC(String DevPath = "");
	virtual void	onLIRCEvent(String Code, int Value, String Button, String DeviceName) = 0;
	virtual void *	threadFunction();
		
	LIRC();
	virtual ~LIRC();
		
private:
	bool		processEvent();
	
	struct sockaddr_un m_Addr;
	char		m_Buf[LIRC_BUF_SIZE];
	String		m_DevPath;
	int		m_FD;
	bool		m_Watching;
};

#endif // __LIRC_h

