  //////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
//
// ScriptFunctionLIRCSetKeyRateLimit.cpp
//
//	ScriptFunctionLIRCSetKeyRateLimit class
//
///////////////////////////////////////
  ///////////////////////////////////////
  
/*

Copyright (c) 2005, Tim Burrell
All rights reserved.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

#include "ScriptFunctionLIRCSetKeyRateLimit.hpp"
#include "libGizmo/Debug.hpp"

////////////////////////////////////////////////////////////////////////////
// Statics / Type Defs
///////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
// Overrides
///////////////////////////////////////

bool ScriptFunctionLIRCSetKeyRateLimit::executeFunction() {
	//Debug::outDebug("ScriptFunctionLIRCSetKeyRateLimit :: executeFunction");
	
	ScriptFuncArg * pInArg1 = getInArg(0);
	if (!pInArg1) {
		Debug::out("ScriptFunctionLIRCSetKeyRateLimit :: executeFunction -- No In Parameter 1!");
		return false;
	}
	
	ScriptFuncArg * pInArg2 = getInArg(1);
	if (!pInArg2) {
		Debug::out("ScriptFunctionLIRCSetKeyRateLimit :: executeFunction -- No Out Parameter 2!");
		return false;
	}
	
	// find device
	LinkList<LIRCInterface> * pPluginList = LIRCInterface::getPluginList();
	if (pPluginList->getSize() == 0) {
		Debug::out("ScriptFunctionLIRCSetKeyRateLimit :: PluginList Badness!");
		return false;
	}
	pPluginList->moveToHead();
	do {
		LIRCInterface * pInt = pPluginList->getData();
		if (pInt->getDeviceID() == pInArg1->ArgNumber) {
			pInt->setKeyRateLimit((int) pInArg2->ArgNumber);
			break;
		}
	} while (pPluginList->moveNext());
		
	return true;
}

////////////////////////////////////////////////////////////////////////////
// Global Funcs
///////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
// Construction
///////////////////////////////////////

ScriptFunctionLIRCSetKeyRateLimit::ScriptFunctionLIRCSetKeyRateLimit(LIRCInterface * pPlugin) {
	m_pPlugin = pPlugin;
	FunctionName.format("lircSetKeyRateLimit");
	FunctionDescription = "Limits the Rate at Which Key Events can be Produced";
	
	addInArg(SCRIPT_ARG_NUMBER);		// IN  DeviceID
	addInArg(SCRIPT_ARG_NUMBER);		// IN  Limit
}

ScriptFunctionLIRCSetKeyRateLimit::~ScriptFunctionLIRCSetKeyRateLimit() {
}

////////////////////////////////////////////////////////////////////////////
// Class Body
///////////////////////////////////////
