  //////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
//
// ScriptFunctionOnPowerMateLEDChange.cpp
//
//	ScriptFunctionOnPowerMateLEDChange class
//
///////////////////////////////////////
  ///////////////////////////////////////
  
/*

Copyright (c) 2005, Tim Burrell
All rights reserved.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

#include "ScriptFunctionOnPowerMateLEDChange.hpp"
#include "libGizmo/Debug.hpp"

////////////////////////////////////////////////////////////////////////////
// Statics / Type Defs
///////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
// Overrides
///////////////////////////////////////

bool ScriptFunctionOnPowerMateLEDChange::executeFunction() {
	Debug::outDebug("ScriptFunctionOnPowerMateLEDChange :: executeFunction");
	
	ScriptFuncArg * pArg = getInArg(0);
	if (!pArg) {
		Debug::out("ScriptFunctionOnPowerMateLEDChange :: executeFunction -- No Parameter!");
		return false;
	}
	
	return true;
}

////////////////////////////////////////////////////////////////////////////
// Global Funcs
///////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
// Construction
///////////////////////////////////////

ScriptFunctionOnPowerMateLEDChange::ScriptFunctionOnPowerMateLEDChange() {
	FunctionName = "onPowerMateLEDChange";
	FunctionDescription = "Called when a PowerMate LED Change Event is Detected";
	
	addInArg(SCRIPT_ARG_NUMBER);	// DeviceID
	addInArg(SCRIPT_ARG_NUMBER);	// Value
	addInArg(SCRIPT_ARG_BOOLEAN);	// Button Pressed
	addInArg(SCRIPT_ARG_STRING);	// DevicePath
}

ScriptFunctionOnPowerMateLEDChange::~ScriptFunctionOnPowerMateLEDChange() {
}

////////////////////////////////////////////////////////////////////////////
// Class Body
///////////////////////////////////////
