  //////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
//
// ScriptFunctionPowerMateSetPulsing.cpp
//
//	ScriptFunctionPowerMateSetPulsing class
//
///////////////////////////////////////
  ///////////////////////////////////////
  
/*

Copyright (c) 2005, Tim Burrell
All rights reserved.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

#include "ScriptFunctionPowerMateSetPulsing.hpp"
#include "libGizmo/Debug.hpp"

////////////////////////////////////////////////////////////////////////////
// Statics / Type Defs
///////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
// Overrides
///////////////////////////////////////

bool ScriptFunctionPowerMateSetPulsing::executeFunction() {
	//Debug::outDebug("ScriptFunctionPowerMateSetPulsing :: executeFunction");
	
	ScriptFuncArg * pInArg1 = getInArg(0);
	if (!pInArg1) {
		Debug::out("ScriptFunctionPowerMateGetLED :: executeFunction -- No In Parameter 1!");
		return false;
	}
	
	ScriptFuncArg * pInArg2 = getInArg(1);
	if (!pInArg2) {
		Debug::out("ScriptFunctionPowerMateSetPulsing :: executeFunction -- No In Param 2!");
		return false;
	}
	
	ScriptFuncArg * pInArg3 = getInArg(2);
	if (!pInArg3) {
		Debug::out("ScriptFunctionPowerMateSetPulsing :: executeFunction -- No In Param 3!");
		return false;
	}
	
	// find device
	LinkList<PowerMateInterface> * pPluginList = PowerMateInterface::getPluginList();
	if (pPluginList->getSize() == 0) {
		Debug::out("ScriptFunctionPowerMateGetLED :: PluginList Badness!");
		return false;
	}
	pPluginList->moveToHead();
	do {
		PowerMateInterface * pInt = pPluginList->getData();
		if (pInt->getDeviceID() == pInArg1->ArgNumber) {
			pInt->onPowerMateSetPulsing((int) pInArg2->ArgNumber, (int) pInArg3->ArgNumber);
			break;
		}
	} while (pPluginList->moveNext());
		
	return true;
}

////////////////////////////////////////////////////////////////////////////
// Global Funcs
///////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
// Construction
///////////////////////////////////////

ScriptFunctionPowerMateSetPulsing::ScriptFunctionPowerMateSetPulsing(PowerMateInterface * pPlugin) {
	m_pPlugin = pPlugin;
	FunctionName.format("powerMateSetPulsing");
	FunctionDescription = "Sets the Hardware Pulsing of the PowerMate";
	
	addInArg(SCRIPT_ARG_NUMBER);		// IN  DeviceID
	addInArg(SCRIPT_ARG_NUMBER);		// IN  Pulse Speed
	addInArg(SCRIPT_ARG_NUMBER);		// IN  Pulse Table
}

ScriptFunctionPowerMateSetPulsing::~ScriptFunctionPowerMateSetPulsing() {
}

////////////////////////////////////////////////////////////////////////////
// Class Body
///////////////////////////////////////
