  //////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
//
// ScriptFunctionOnSoundVisualization.cpp
//
//	ScriptFunctionOnSoundVisualization class
//
///////////////////////////////////////
  ///////////////////////////////////////
  
/*

Copyright (c) 2005, Tim Burrell
All rights reserved.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

#include "ScriptFunctionOnSoundVisualization.hpp"
#include "libGizmo/Debug.hpp"

////////////////////////////////////////////////////////////////////////////
// Statics / Type Defs
///////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
// Overrides
///////////////////////////////////////

bool ScriptFunctionOnSoundVisualization::executeFunction() {
	Debug::outDebug("ScriptFunctionOnSoundVisualization :: executeFunction");
	
	ScriptFuncArg * pArg = getInArg(0);
	if (!pArg) {
		Debug::out("ScriptFunctionOnSoundVisualization :: executeFunction -- No Parameter!");
		return false;
	}
	
	return true;
}

////////////////////////////////////////////////////////////////////////////
// Global Funcs
///////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
// Construction
///////////////////////////////////////

ScriptFunctionOnSoundVisualization::ScriptFunctionOnSoundVisualization() {
	FunctionName = "onSoundVisualization";
	FunctionDescription = "Called when a Sound Visualization Event happens";
	
	addInArg(SCRIPT_ARG_NUMBER);	// Frame ID
	addInArg(SCRIPT_ARG_NUMBER);	// Left Channel
	addInArg(SCRIPT_ARG_NUMBER);	// Right Channel
	addInArg(SCRIPT_ARG_NUMBER);	// Combined
	addInArg(SCRIPT_ARG_NUMBER);	// Special
}

ScriptFunctionOnSoundVisualization::~ScriptFunctionOnSoundVisualization() {
}

////////////////////////////////////////////////////////////////////////////
// Class Body
///////////////////////////////////////
