  ///////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////
//
// XOSD.hpp
//
//	XOSD header file
//
///////////////////////////////////////
  ///////////////////////////////////////
  
/*

Copyright (c) 2005, Tim Burrell
All rights reserved.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

#ifndef __XOSD_h
#define __XOSD_h

#if HAVE_CONFIG_H
#include "config.h"
#endif

#include <xosd.h>
#include "libGizmo/String.hpp"

//////////////////////////////////////////////////////////////////////////////
// Typedefs, etc
///////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
// Class Definition
///////////////////////////////////////

class XOSD {
public:
	bool 		init(String Font, int FontSize, String FontColor);
	void		close();
	void 		displaySlider(int Line, int value);
	void 		displayPercentage(int Line, int value);
	bool		getXOSDIsOnScreen();
	void 		printString(int Line, const char * TextToOutput, ...);
	void		setXOSDEnable(bool Enabled);
	bool 		setXOSDFont(String Font);
	bool 		setXOSDFontColor(String FontColor);
	bool 		setXOSDFontSize(int FontSize);
	
	XOSD(int MaxLines);
	virtual ~XOSD();
	
private:
	xosd *		m_xosd;
	int		m_MaxLines;
	int		m_Enabled;
	String		m_Font;
	int		m_FontSize;
	String		m_FontColor;
};

#endif // __XOSD_h

