  ///////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////
//
// XOSDInterface.hpp
//
//	XOSDInterface header file
//
///////////////////////////////////////
  ///////////////////////////////////////
  
/*

Copyright (c) 2005, Tim Burrell
All rights reserved.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

#ifndef __XOSDInterface_h
#define __XOSDInterface_h

#if HAVE_CONFIG_H
#include "config.h"
#endif

#include "libGizmo/LinkList.hpp"
#include "libGizmo/String.hpp"
#include "libGizmo/GizmoPlugin.hpp"

//////////////////////////////////////////////////////////////////////////////
// Typedefs
///////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
// Class Definition
///////////////////////////////////////

class XOSDInterface : public GizmoPlugin {
public:
	virtual void 	xosdDisplaySlider(int value) = 0;
	virtual void 	xosdDisplayPercentage(int value) = 0;
	int		getDeviceID();
	virtual bool	xosdGetIsOnScreen() = 0;
	virtual void 	xosdPrintString(int Line, const char * TextToOutput, ...) = 0;
	virtual void	xosdSetEnable(bool Enabled) = 0;
	virtual bool 	xosdSetFontName(String Font) = 0;
	virtual bool 	xosdSetFontColor(String FontColor) = 0;
	virtual bool 	xosdSetFontSize(int FontSize) = 0;
			
	XOSDInterface();
	virtual ~XOSDInterface();

	static LinkList<XOSDInterface> * getPluginList();

protected:
	int		m_DeviceID;
	String		m_DevicePath;
	String		m_DeviceName;
	
private:
	static int	m_DeviceIDCurrent;
	static LinkList<XOSDInterface> m_PluginList;
};

#endif // __XOSDInterface_h

